# Description

This mod pulls nearby items from the ground into containers. Optionally, use a hotkey to store items in your inventory
into containers. WardIsLove compatible, HotBar items can be ignored (on by default), Quickslots can be
ignored (`if turned on in the configuration!`).

This is meant to be a small re-write to the OdinsQOL AutoStore feature. Externalized and now standalone.

## 1. Need to know

`Version checks with itself. If installed on the server, it will kick clients who do not have it installed.`

`This mod uses ServerSync, if installed on the server and all clients, it will sync all configs to client`

`This mod uses a file watcher. If the configuration file is not changed with BepInEx Configuration manager, but changed in the file directly on the server, upon file save, it will sync the changes to all clients.`

## 2. Configuration (Collapsed due to length. Click to expand)

<details> <summary><b>Available Configuration Options</b></summary>



`1 - General`

Lock Configuration [Synced with Server]

* If on, the configuration is locked and can be changed by server admins only.
    * Default Value: On

Highlight Containers [Not Synced with Server]
* If on, the containers will be highlighted when something is stored in them. If off, the containers will not be highlighted if something is stored in them.
  * Default Value: On

Must Have Existing Item To Pull [Synced with Server]

* If on, the chest must already have the item in its inventory to pull it from the world or player into the chest.
    * Default Value: On

Store Shortcut [Not Synced with Server]

* Keyboard shortcut/Hotkey to store your inventory into nearby containers.
    * Default Value: Period

Player Range [Synced with Server]

* The maximum distance from the player to store items in chests when the Store Shortcut is pressed. Follows storage
  rules for allowed items.
    * Default Value: 5

Player Ignore Hotbar [Not Synced with Server]

* If on, the player's hotbar will not be stored when the Store Shortcut is pressed.
    * Default Value: Off

Player Ignore Quick Slots [Not Synced with Server]

* If on, the player's quick slots will not be stored when the Store Shortcut is pressed. (Requires Quick Slots mod, turn
  on only if you need it!)
    * Default Value: Off

Ping VFX [Synced with Server]

* The VFX to play when a chest is pinged. Leave blank to disable and only highlight the chest. (Full prefab
  list: https://valheim-modding.github.io/Jotunn/data/prefabs/prefab-list.html)
    * Default Value: vfx_Potion_health_medium

`2 - All Chests (Default/Override)`

Pickup Range [Synced with Server]

* The range in which the chest will pick up items dropped near it.
    * Default Value: 5

Allowed Items [Synced with Server]

* List of items (using their prefab names) that are allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value:

Disallowed Items [Synced with Server]

* List of items (using their prefab names) are not allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value:

Allowed Categories [Synced with Server]

* List of item categories that are allowed to be stored in the chests. Leave empty to allow all items.
    * Default Value: Material, OneHandedWeapon, Bow, Shield, Helmet, Chest, Customization, Legs, Hands, Trophie,
      TwoHandedWeapon, Torch, Misc, Shoulder, Utility, Tool, Attach_Atgeir, Fish, TwoHandedWeaponLeft

`3 - Personal Chests`

Pickup Range [Synced with Server]

* The range in which the chest will pick up items dropped near it.
    * Default Value: 5

Allowed Items [Synced with Server]

* List of items (using their prefab names) are allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value:

Disallowed Items [Synced with Server]

* List of items (using their prefab names) are not allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value:

Allowed Categories [Synced with Server]

* List of item categories that are allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value: Material, OneHandedWeapon, Bow, Shield, Helmet, Chest, Customization, Legs, Hands, Trophie,
      TwoHandedWeapon, Torch, Misc, Shoulder, Utility, Tool, Attach_Atgeir, Fish, TwoHandedWeaponLeft

`4 - Reinforced Chests`

Pickup Range [Synced with Server]

* The range in which the chest will pick up items dropped near it.
    * Default Value: 5

Allowed Items [Synced with Server]

* List of items (using their prefab names) are allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value:

Disallowed Items [Synced with Server]

* List of items (using their prefab names) are not allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value:

Allowed Categories [Synced with Server]

* List of item categories that are allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value: Material, OneHandedWeapon, Bow, Shield, Helmet, Chest, Customization, Legs, Hands, Trophie,
      TwoHandedWeapon, Torch, Misc, Shoulder, Utility, Tool, Attach_Atgeir, Fish, TwoHandedWeaponLeft

`5 - Blackmetal Chests`

Pickup Range [Synced with Server]

* The range in which the chest will pick up items dropped near it.
    * Default Value: 5

Allowed Items [Synced with Server]

* List of items (using their prefab names) are allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value:

Disallowed Items [Synced with Server]

* List of items (using their prefab names) are not allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value:

Allowed Categories [Synced with Server]

* List of item categories that are allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value: Material, OneHandedWeapon, Bow, Shield, Helmet, Chest, Customization, Legs, Hands, Trophie,
      TwoHandedWeapon, Torch, Misc, Shoulder, Utility, Tool, Attach_Atgeir, Fish, TwoHandedWeaponLeft

`6 - Custom Chests`

Custom Chests [Synced with Server]

* List of custom chest prefabs to add to the config. Separate each prefab name with a comma. (Use XRayVision mod or VNEI
  to get the prefab names if you have no idea what they are.)
    * Default Value:

Pickup Range [Synced with Server]

* The range in which the chest will pick up items dropped near it.
    * Default Value: 5

Allowed Items [Synced with Server]

* List of items (using their prefab names) are allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value:

Disallowed Items [Synced with Server]

* List of items (using their prefab names) are not allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value:

Allowed Categories [Synced with Server]

* List of item categories that are allowed to be stored in the chest. Leave empty to allow all items.
    * Default Value: Material, OneHandedWeapon, Bow, Shield, Helmet, Chest, Customization, Legs, Hands, Trophie,
      TwoHandedWeapon, Torch, Misc, Shoulder, Utility, Tool, Attach_Atgeir, Fish, TwoHandedWeaponLeft

`7 - Carts`

Pickup Range [Synced with Server]

* The range in which items will be dropped from the cart.
    * Default Value: 5

Allowed Items [Synced with Server]

* List of items (using their prefab names) are allowed to be stored in the cart. Leave empty to allow all items.
    * Default Value:

Disallowed Items [Synced with Server]

* List of items (using their prefab names) are not allowed to be stored in the cart. Leave empty to allow all items.
    * Default Value:

Allowed Categories [Synced with Server]

* List of item categories that are allowed to be stored in the cart. Leave empty to allow all items.
    * Default Value: Material, OneHandedWeapon, Bow, Shield, Helmet, Chest, Customization, Legs, Hands, Trophie,
      TwoHandedWeapon, Torch, Misc, Shoulder, Utility, Tool, Attach_Atgeir, Fish, TwoHandedWeaponLeft

`8 - Ships`

Pickup Range [Synced with Server]

* The range in which items will be dropped from the ship.
    * Default Value: 5

Allowed Items [Synced with Server]

* List of items (using their prefab names) are allowed to be stored in the ship. Leave empty to allow all items.
    * Default Value:

Disallowed Items [Synced with Server]

* List of items (using their prefab names) are not allowed to be stored in the ship. Leave empty to allow all items.
    * Default Value:

Allowed Categories [Synced with Server]

* List of item categories that are allowed to be stored in the ship. Leave empty to allow all items.
    * Default Value: Material, OneHandedWeapon, Bow, Shield, Helmet, Chest, Customization, Legs, Hands, Trophie,
      TwoHandedWeapon, Torch, Misc, Shoulder, Utility, Tool, Attach_Atgeir, Fish, TwoHandedWeaponLeft

</details>



`Feel free to reach out to me on discord if you need manual download assistance.`

# Author Information

### Azumatt

`DISCORD:` Azumatt#2625

`STEAM:` https://steamcommunity.com/id/azumatt/

For Questions or Comments, find me in the Odin Plus Team Discord or in mine:

[![https://i.imgur.com/XXP6HCU.png](https://i.imgur.com/XXP6HCU.png)](https://discord.gg/Pb6bVMnFb2)
<a href="https://discord.gg/pdHgy6Bsng"><img src="https://i.imgur.com/Xlcbmm9.png" href="https://discord.gg/pdHgy6Bsng" width="175" height="175"></a>
***

> # Update Information (Latest listed first)
> ### v1.0.2
> - Fixes that I can't remember. ALo helped find the bugs
> - Added a new config option to allow you to disable the chest highlight
> - Prevent typing your hotkey while any UI is open so you don't store your items in the chest by accident
> ### v1.0.1
> - AmmoNonEquipable item type missing fixed
> ### v1.0.0
> - Initial Release